
package de.ivu.elect.presentation.kandidatenportal;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerConversationStore;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerExtendedDAO;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerEdit;
import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer;
import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractWvpBenutzerEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractWvpBenutzerEditNoScopeView.VIEW_ID, useCase = UseCasePermission.WVP_BENUTZER_EDIT)
public abstract class AbstractWvpBenutzerEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<WvpBenutzer>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wvpBenutzerEditView";

  public static final String VIEW_ID = "/kandidatenportal/wvp-benutzer-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/kandidatenportal/wvp-benutzer-search.xhtml";

  @Inject
  protected transient WvpBenutzerExtendedDAO extendedDAO;

  @Inject
  protected transient WvpBenutzerEdit edit;

  @Inject
  @ConversationGroup(WvpBenutzerConversationStore.class)
  protected transient WvpBenutzerConversationStore conversationStore;

  @Inject
  protected transient WvpBenutzerMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient WvpBenutzerEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public WvpBenutzer getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(WvpBenutzer entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WVP_BENUTZER_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(WvpBenutzer entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.WVP_BENUTZER_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.WVP_BENUTZER_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WVP_BENUTZER_EDIT)
  @Override
  public String save() {
    WvpBenutzer entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(WvpBenutzer entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    WvpBenutzer entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(WvpBenutzer entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.WVP_BENUTZER_EDIT);
  }
  
  @Redirect
  public String edit(WvpBenutzer entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class WvpBenutzerEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<WvpBenutzer,  de.ivu.elect.business.person.entity.PersonendatenPK  > {

    private static final long serialVersionUID = 1L;
  }
}
